


#variable Started 0

if {![info exists Started]} {variable Started 0}

if {$Started != 0} {

     variable Skip0
     variable DefCont
     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$Started == 0} {           ;#  first time load code and define local variables


    set Started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable SpecName "*"
    variable SpecData ""
    variable SpecCont ""
    variable SpecLength ""
    variable DataLength ""
    variable SpecTitle ""
    variable SpecShow 0
    variable SpectrumList {}
    variable SpecDim 1
    variable SpecB 0
    variable SpecR 1024
    variable SpecArgs {}
    variable DataList {}
    variable SearchName 0
    variable XMin 0
    variable XMax 65535
    variable CanvasX 512
    variable CanvasY 512
    variable SpecBase 0
    variable SpecRange 65536
    variable SpecBase0 0
    variable SpecRange0 256
    variable SpecBase 0
    variable SpecRange 256
    variable Skip0 0
    variable DefCont 0
    variable Showing 0

    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
    }

   proc do_create2D {} {
       variable SpecName
       variable SpecB
       variable SpecR
       variable SpecArgs
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecNew  $SpecName "$SpecB" "$SpecR" "$SpecArgs"} msg]

       if {$z == 0} {
           InsertLog "SpecNew returned: [lindex $msg 5]"
       } else {
           InsertLog "SpecNew failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_create1D {} {
       variable SpecName
       variable SpecB
       variable SpecR
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecNew  $SpecName "$SpecB" "$SpecR"} msg]

       if {$z == 0} {
           InsertLog "SpecNew returned: [lindex $msg 5]"
       } else {
           InsertLog "SpecNew failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_the_inquiry {name} {
       global errorCode errorInfo
       variable SpectrumList

       set z [catch {::namespace inscope ::urn:SpectrumService SpecNames $name} msg]

       if {$z == 0} {
#           InsertLog "SpecNames returned:"
           set SpectrumList {}
           foreach item [lindex $msg 5] {
             lappend SpectrumList $item
#            InsertLog "$item"
           }
           set SpectrumList [lsort -dictionary $SpectrumList]
       } else {
           InsertLog "SpecNames failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_inquire {} {
       variable SpecName
       do_the_inquiry $SpecName
   }

   proc do_inquire_all {} {
       do_the_inquiry *
   }

   proc do_details {} {
       variable SpecName
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecDetails $SpecName} msg]

       if {$z == 0} {
           InsertLog "SpecDetails returned:"
           foreach item [lindex $msg 5] {InsertLog "$item"}
       } else {
           InsertLog "SpecDetails failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_title {} {
       variable SpecName
       global errorCode errorInfo
       variable DataList

       set z [catch {::namespace inscope ::urn:SpectrumService SpecGetTitle $SpecName} msg]

       if {$z == 0} {
           InsertLog "SpecGetTitle returned:"
           set DataList [lindex $msg 5]; InsertLog "[lindex $msg 5]"
       } else {
           InsertLog "SpecGetTitle failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_read {args} {
       variable SpecName
       global errorCode errorInfo

       if {[llength $args] == 0} {set b 0; set r 0}
       if {[llength $args] == 1} {set b 0; set r [first $args]}
       if {[llength $args] >= 2} {set b [first $args]; set r [second $args]}

       set z [catch {::namespace inscope ::urn:SpectrumService SpecRead1DText $SpecName $b $r} msg]

       if {$z == 0} {
           InsertLog "SpecRead1DText returned:"
           foreach item [lindex $msg 5] {InsertLog "$item"}

       } else {
           InsertLog "SpecRead1DText failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }


   proc do_skip {skip} {
       variable Skip0
       variable XMin
       variable SpecBase
       if {$skip == "true" || $skip == 1} {
         set Skip0 1
       } else {
         set Skip0 0
         if {$XMin == 1} {set XMin $SpecBase}
       }
   }

   proc do_cont {def} {
       variable DefCont
       if {$def == "true" || $def == 1} {
         set DefCont 1
       } else {
         set DefCont 0
       }
   }

   proc do_show_2d {args} {
       variable SpecName
       variable SpecTitle
       variable SpecData
       variable SpecCont
       variable SpecLength
       variable SpecShow
       variable SpecBase0
       variable SpecRange0
       variable SpecBase1
       variable SpecRange1
       variable Skip0
       variable XMin
       variable XMax
       variable CanvasX
       variable CanvasY
       variable Showing
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecDetails $SpecName} msg]
       if {$z == 0} {
           set details [lindex $msg 5]
           set SpecBase0 [first [second $details]]
           set SpecBase1 [second [second $details]]
           set SpecRange0 [first [third $details]]
           set SpecRange1 [second [third $details]]
       }

       set z [catch {::namespace inscope ::urn:SpectrumService SpecGetTitle $SpecName} msg]
       if {$z == 0} {
           set SpecTitle [lindex $msg 5]
           if {$SpecTitle == ""} {set SpecTitle $SpecName} {set SpecTitle "$SpecTitle ($SpecName)"}
       } else {
           InsertLog "SpecGetTitle failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }

       set canvaswidth 512

       set xscale [expr $canvaswidth / $SpecRange0]
       set yscale [expr $canvaswidth / $SpecRange1]
       if {$canvaswidth > $SpecRange0 && $canvaswidth > $SpecRange1} {
          set xscale [expr max(1, int(((10.0 * $xscale)+5.0)/10.0))]
          set yscale [expr max(1, int(((10.0 * $yscale)+5.0)/10.0))]
       }
       set xscale [expr min($xscale, $yscale)]
       set yscale [expr min($xscale, $yscale)]
       set cx [expr int($SpecRange0*$xscale)]
       if {!$cx} {set cx $canvaswidth}
       set cy [expr int($SpecRange1*$yscale)]
       if {!$cy} {set cy $canvaswidth}

#       set val [expr $SpecRange0 / $cx]
       set val [expr max(1, ($SpecRange0 / $cx))]
       set Cmp0 $val;
#       set val [expr $SpecRange1 / $cy]
#       set val [expr max(1, $val)]
       set val [expr max(1, ($SpecRange1 / $cy))]
       set CanvasX $cx; set CanvasY $cy;
       set Cmp1 $val;
       set Compression [expr max($Cmp0, $Cmp1)];

#       set Compression [expr max(1, $SpecRange0 / 512)]
#       set Compression [expr max($Compression, $SpecRange1 / 512)]
#       InsertLog "Using $Compression Compression"
       set z [catch {::namespace inscope ::urn:SpectrumService SpecRead2DText $SpecName $SpecBase0 $SpecRange0 $SpecBase1 $SpecRange1 $Compression $Compression} msg]
       if {$z == 0} {
#           InsertLog "SpecRead2DText returned [llength [lindex $msg 5]]"
           set SpecData ""
           set data [lindex $msg 5]
           set SpecLength [llength $data]
#           InsertLog ": $SpecLength"
           set comp0 [expr $SpecRange0 / $Compression]
           set comp1 [expr $SpecRange1 / $Compression]
           set SpecLength0 [expr $SpecLength / $comp1]
           set SpecLength1 [expr $SpecLength / $comp0]
           set DataLength0 [expr min($comp0, $SpecLength0)]
           set DataLength1 [expr min($comp1, $SpecLength1)]

           set zmin 0; set zmax 0;
           for {set i 0; set c $SpecBase0; set bc 0} {$c < [expr $SpecBase0 + int($SpecRange0/$Cmp1)]} {incr i; incr c} {
              for {set j 0; set x 0} {$x < [expr int($SpecRange1/$Cmp0)-1]} {incr j; incr x} {
                set item [lindex $data $bc]
                if {$item < $zmin} {set zmin $item}
                if {$item > $zmax} {set zmax $item}
                append SpecData "\[[expr $i],[expr $j],$item\], "
                incr bc
              }
              set item [lindex $data $bc]
              if {$item < $zmin} {set zmin $item}
              if {$item > $zmax} {set zmax $item}
              if {[expr $c+1] >= [expr $SpecBase0 + int($SpecRange0/$Cmp1)]} {
                append SpecData "\[[expr $i],[expr $j],$item\]"
              } else {
                append SpecData "\[[expr $i],[expr $j],$item\], "
              }
              incr bc
           }
           set step  [expr ((abs(int(($zmax - $zmin)) + 1) / 31))]
           if {$step < 1} {set step 1}
           set SpecCont ""
           for {set i 0} {$i<30} {incr i} {
             append SpecCont "[expr $zmin + $step * $i], "
           }
           append SpecCont "[expr $zmin + $step * $i]"

           set SpecShow 2
       } else {
           InsertLog "SpecRead2DText failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }
       set Showing 2
   }

   proc do_show_1d {args} {
       variable SpecName
       variable SpecTitle
       variable SpecData
       variable SpecLength
       variable SpecShow
       variable SpecBase
       variable SpecRange
       variable Skip0
       variable XMin
       variable XMax
       variable Showing
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecDetails $SpecName} msg]
       if {$z == 0} {
           set details [lindex $msg 5]
           set SpecDim [first $details]
           if {$SpecDim == 2} {do_show2d; return}
           if {$SpecDim != 1} {InsertLog "Spectrum Dimension is $SpecDim; only 1d & 2d supported"; return}
           set SpecBase [second $details]
           if {$XMin < $SpecBase} {set XMin $SpecBase}
           if {$XMax >= [third $details]} {set XMax [expr [third $details] - 1]}
           if {$XMin > $XMax} {set XMin $SpecBase}
           if {$XMin == $SpecBase && $Skip0} {set XMin [expr $SpecBase + 1]}
           set SpecRange [expr $XMax - $XMin + 1]
       } else {
           InsertLog "SpecDetails failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }

       set z [catch {::namespace inscope ::urn:SpectrumService SpecGetTitle $SpecName} msg]
       if {$z == 0} {
           set SpecTitle [lindex $msg 5]
           if {$SpecTitle == ""} {set SpecTitle $SpecName} {set SpecTitle "$SpecTitle ($SpecName)"}
       } else {
           InsertLog "SpecGetTitle failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }

       set Compression [expr max(1, $SpecRange / 1024)]
#       InsertLog "Using $Compression Compression"
       set z [catch {::namespace inscope ::urn:SpectrumService SpecRead1DText $SpecName $XMin $SpecRange $Compression} msg]
       if {$z == 0} {
#           InsertLog "SpecRead1DText returned [llength [lindex $msg 5]]"
           set SpecData ""
           set data [lindex $msg 5]
           set SpecLength [llength $data]
#           InsertLog "SpecRead1DText returned $SpecLength"
           set comp [expr $SpecRange / $Compression]
           set DataLength [expr min($comp, $SpecLength)]
           set leng $DataLength
           set j $XMin
           for {set i 0} {$i < $leng} {incr i} {
             set item [lindex $data $i]
             append SpecData "\[[expr $j],$item\],"
             incr j $Compression
           }
           set item [lindex $data $i]
#           append SpecData "\[[expr $j],0\]"
           set SpecShow 1
       } else {
           InsertLog "SpecRead1DText failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }
       set Showing 1
   }

   proc do_show {args} {
       variable SpecName
       global errorCode errorInfo

#puts "do_show $SpecName"

       set z [catch {::namespace inscope ::urn:SpectrumService SpecDetails $SpecName} msg]
       if {$z == 0} {
           set details [lindex $msg 5]
           set dim [first $details]
           if {$dim == 1} {do_show_1d; return}
           if {$dim == 2} {do_show_2d; return}
           InsertLog "Spectrum Dimension is $dim; only 1d & 2d supported"; return
       } else {
           InsertLog "SpecDetails failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }
   }

   proc do_delete {} {
       variable SpecName 
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecDelete $SpecName} msg]

       if {$z == 0} {
           InsertLog "SpecDelete returned: [lindex $msg 5]"
       } else {
           InsertLog "SpecDelete failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_zero {} {
       variable SpecName
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecZero $SpecName} msg]

       if {$z == 0} {
           InsertLog "SpecZero returned: [lindex $msg 5]"
           set RegData [second [first [lindex $msg 5]]]
       } else {
           InsertLog "SpecZero failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }


   proc do_click {} {
       variable cgidata
       variable Started
       variable LogFlag
       variable ShowLogFlag
       variable JS
       variable SpecName
       variable SearchName
       variable SpecDim
       variable Skip0
       variable XMin
       variable XMax
       variable Showing

       set SearchName 0

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

               set w [lindex $cgidata 1]
               set showit $Showing
               set Showing 0

               switch -glob [lindex $w 0] {

                   RESET    {set Started 0; set showit 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {; set showit 0}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   CREATE   {
                        if {$SpecDim == 1} {do_create1D}
                        if {$SpecDim == 2} {do_create2D}
                        set showit 0
                   }
                   DELETE   {do_delete; set showit 0}
                   ZERO     {do_zero; set showit 0}

                   INQUIRE    {do_inquire}
                   INQUIREALL {do_inquire_all}

                   READ     {do_read 32}
                   SPECSHOW {do_show; set showit 0}
                   SPECSKIP {do_skip [lindex $w 1]}
                   SPECCONT {do_cont [lindex $w 1]}

                   SPECNAMES -
                   SPECNAME {set SpecName [lindex $w 1]; set SearchName 1; set showit 0}

                   XMIN     {set XMin [lindex $w 1]}
                   XMAX     {set XMax [lindex $w 1]}

                   DETAILS  {do_details}
                   TITLE    {do_title}
                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"; set showit 0}
               }
           }
       }
       if {$showit} {do_show}
    }

    do_inquire_all
    set html ""

}   ;# end of if {$Started == 0}



